# -*- coding: utf-8 -*-
#
# File: ExternalApplication.py
#
# Copyright (c) 2009 by PloneGov
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Gaetan DELANNAY <gaetan.delannay@geezteem.com>, Gauthier BASTIEN
<gbastien@commune.sambreville.be>, Stephan GEULETTE
<stephan.geulette@uvcw.be>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMeeting.config import *

##code-section module-header #fill in your manual code here
import urllib, urllib2
from Products.PloneMeeting.utils import getCustomAdapter
from Products.PloneMeeting.profiles import ExternalApplicationDescriptor
defValues = ExternalApplicationDescriptor.get()
from Products.PloneMeeting.utils import sendMail
import logging
logger = logging.getLogger('PloneMeeting')
##/code-section module-header

schema = Schema((

    StringField(
        name='notifyUrl',
        default= defValues.notifyUrl,
        widget=StringWidget(
            description="NotifyUrl",
            description_msgid="notify_url_descr",
            size=70,
            label='Notifyurl',
            label_msgid='PloneMeeting_label_notifyUrl',
            i18n_domain='PloneMeeting',
        ),
        validators=('isURL',)
    ),

    StringField(
        name='notifyEmail',
        default= defValues.notifyEmail,
        widget=StringWidget(
            description="NotifyEmail",
            description_msgid="notify_email_descr",
            size=70,
            label='Notifyemail',
            label_msgid='PloneMeeting_label_notifyEmail',
            i18n_domain='PloneMeeting',
        ),
        validators=('isEmail',)
    ),

    StringField(
        name='notifyProxy',
        default= defValues.notifyProxy,
        widget=StringWidget(
            description="NotifyProxy",
            description_msgid="notify_proxy_descr",
            size=70,
            label='Notifyproxy',
            label_msgid='PloneMeeting_label_notifyProxy',
            i18n_domain='PloneMeeting',
        ),
        validators=('isURL',)
    ),

    StringField(
        name='notifyLogin',
        default= defValues.notifyLogin,
        widget=StringWidget(
            description="NotifyLogin",
            description_msgid="notify_login_descr",
            label='Notifylogin',
            label_msgid='PloneMeeting_label_notifyLogin',
            i18n_domain='PloneMeeting',
        )
    ),

    StringField(
        name='notifyPassword',
        default= defValues.notifyPassword,
        widget=PasswordWidget(
            description="NotifyPassword",
            description_msgid="notify_password_descr",
            label='Notifypassword',
            label_msgid='PloneMeeting_label_notifyPassword',
            i18n_domain='PloneMeeting',
        )
    ),

    StringField(
        name='loginHeaderKey',
        default= defValues.loginHeaderKey,
        widget=StringWidget(
            description="LoginHeaderKey",
            description_msgid="login_header_key_descr",
            label='Loginheaderkey',
            label_msgid='PloneMeeting_label_loginHeaderKey',
            i18n_domain='PloneMeeting',
        )
    ),

    StringField(
        name='passwordHeaderKey',
        default= defValues.passwordHeaderKey,
        widget=StringWidget(
            description="PasswordHeaderKey",
            description_msgid="password_header_key_descr",
            label='Passwordheaderkey',
            label_msgid='PloneMeeting_label_passwordHeaderKey',
            i18n_domain='PloneMeeting',
        )
    ),

    StringField(
        name='meetingParamName',
        default= defValues.meetingParamName,
        widget=StringWidget(
            description="MeetingParamName",
            description_msgid="meeting_param_name_descr",
            label='Meetingparamname',
            label_msgid='PloneMeeting_label_meetingParamName',
            i18n_domain='PloneMeeting',
        ),
        required=True
    ),

    StringField(
        name='notifyProtocol',
        default= defValues.notifyProtocol,
        widget=SelectionWidget(
            description="NotifyProtocol",
            description_msgid="notify_protocol_descr",
            label='Notifyprotocol',
            label_msgid='PloneMeeting_label_notifyProtocol',
            i18n_domain='PloneMeeting',
        ),
        enforceVocabulary=True,
        vocabulary='listProtocols'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

ExternalApplication_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
from Products.PloneMeeting.model.extender import ModelExtender
ExternalApplication_schema = ModelExtender(
    ExternalApplication_schema, 'extapp').run()
##/code-section after-schema

class ExternalApplication(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'ExternalApplication'

    meta_type = 'ExternalApplication'
    portal_type = 'ExternalApplication'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 1
    #content_icon = 'ExternalApplication.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "ExternalApplication"
    typeDescMsgId = 'description_edit_externalapplication'

    _at_rename_after_creation = True

    schema = ExternalApplication_schema

    ##code-section class-header #fill in your manual code here
    URL_NOTIFY_ERROR = 'Application "%s" could not be contacted at URL "%s". ' \
                       'I will try to send him a mail instead (if an email ' \
                       'address is defined for this application (Error is: %s).'
    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declarePublic('listProtocols')
    def listProtocols(self):
        res = DisplayList(( ("httpGet", 'HTTP GET'),
                            ("httpPost", 'HTTP POST') ))
        return res

    security.declarePublic('notify')
    def notify(self, meeting=None):
        '''Notifies the external app I represent that p_meeting has been
           archived. If p_meeting is None, a dummy meetingUrl will be sent
           for testing purposes.'''
        mustSendMail = True
        if not meeting:
            meetingUrl = '/dummy/meeting'
        else:
            meetingUrl = meeting.absolute_url_path()
        res = None
        if self.getNotifyUrl():
            mustSendMail = False
            # Try to send a HTTP request, with the meeting URL as param
            params = urllib.urlencode({self.getMeetingParamName(): meetingUrl})
            extAppUrl = self.getNotifyUrl()
            if self.getNotifyProtocol() == 'httpGet':
                extAppUrl = '%s?%s' % (extAppUrl, params)
            httpReq = urllib2.Request(extAppUrl)
            if self.getNotifyProtocol() == 'httpPost':
                httpReq.add_data(params)
            if self.getNotifyLogin():
                httpReq.add_header(self.getLoginHeaderKey(),
                                   self.getNotifyLogin())
                httpReq.add_header(self.getPasswordHeaderKey(),
                                   self.getNotifyPassword())
            if self.getNotifyProxy():
                httpReq.set_proxy(self.getNotifyProxy(), 'http')
            try:
                response = urllib2.urlopen(httpReq)
                if response:
                    res = response.read()
            except IOError, ioe:
                res = str(ioe)
                logger.warn(self.URL_NOTIFY_ERROR % (self.Title(), extAppUrl,
                                                     res))
                mustSendMail = True
        # Try to send a mail if needed
        if mustSendMail and self.getNotifyEmail():
            obj = meeting
            if not meeting:
                obj = self
            sendMail([self.getNotifyEmail()], obj, 'meetingIsArchived')
        return res

    security.declarePrivate('at_post_create_script')
    def at_post_create_script(self): self.adapted().onEdit(isCreated=True)

    security.declarePrivate('at_post_edit_script')
    def at_post_edit_script(self): self.adapted().onEdit(isCreated=False)

    security.declarePublic('getSelf')
    def getSelf(self):
        if self.__class__.__name__ != 'ExternalApplication': return self.context
        return self

    security.declarePublic('adapted')
    def adapted(self): return getCustomAdapter(self)

    security.declareProtected('Modify portal content', 'onEdit')
    def onEdit(self, isCreated): '''See doc in interfaces.py.'''



registerType(ExternalApplication, PROJECTNAME)
# end of class ExternalApplication

##code-section module-footer #fill in your manual code here
##/code-section module-footer



