# -*- coding: utf-8 -*-
#
# File: MeetingFile.py
#
# Copyright (c) 2009 by PloneGov
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Gaetan DELANNAY <gaetan.delannay@geezteem.com>, Gauthier BASTIEN
<gbastien@commune.sambreville.be>, Stephan GEULETTE
<stephan.geulette@uvcw.be>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMeeting.config import *

##code-section module-header #fill in your manual code here
from Products.CMFCore.permissions import View
from Products.ATContentTypes.content.file import ATFile, ATFileSchema
from Products.PloneMeeting.utils import clonePermissions, getCustomAdapter
##/code-section module-header

schema = Schema((

    ReferenceField(
        name='meetingFileType',
        widget=ReferenceField._properties['widget'](
            label='Meetingfiletype',
            label_msgid='PloneMeeting_label_meetingFileType',
            i18n_domain='PloneMeeting',
        ),
        required=True,
        relationship="MeetingFileType"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

MeetingFile_schema = ATFileSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
# Integrate potential extensions from PloneMeeting sub-products
from Products.PloneMeeting.model.extender import ModelExtender
MeetingFile_schema = ModelExtender(MeetingFile_schema, 'file').run()
##/code-section after-schema

class MeetingFile(ATFile):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATFile,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'MeetingFile'

    meta_type = 'MeetingFile'
    portal_type = 'MeetingFile'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 1
    #content_icon = 'MeetingFile.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "MeetingFile"
    typeDescMsgId = 'description_edit_meetingfile'


    actions =  (


       {'action': "string:${object_url}/file_view",
        'category': "object",
        'id': 'view',
        'name': 'View',
        'permissions': ("View",),
        'condition': 'python:not here.portal_factory.isTemporary(here)'
       },


    )

    _at_rename_after_creation = True

    schema = MeetingFile_schema

    ##code-section class-header #fill in your manual code here
    aliases = {
        '(Default)'  : '(dynamic view)',
        'view'       : 'file_view',
        'index.html' : '(dynamic view)',
        'edit'       : 'atct_edit',
        'properties' : 'base_metadata',
        'sharing'    : 'folder_localrole_form',
        'gethtml'    : '',
        'mkdir'      : '',
        }
    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declarePublic('getIcon')
    def getIcon(self, relative_to_portal=0):
        '''Calculate the icon using the meetingFileType icon.'''
        field = self.getField('file')
        if not field:
            # field is empty
            return BaseContent.getIcon(self, relative_to_portal)
        mtf = self.getMeetingFileType()
        if mtf:
            return mtf.absolute_url(relative=1) + "/theIcon"
        else:
            return None

    security.declarePublic('getBestIcon')
    def getBestIcon(self):
        '''Calculates the icon for the AT default view'''
        self.getIcon()

    security.declarePublic('getItem')
    def getItem(self):
        '''Returns the linked item.'''
        # getBRefs returns links of the ReferenceField
        res = self.getBRefs('ItemAnnexes')
        if res:
            res = res[0]
        else:
            res = self.getBRefs('DecisionAnnexes')
            if res:
                res = res[0]
        return res

    security.declarePublic('updateAnnexSecurity')
    def updateAnnexSecurity(self):
        '''Applies the same security settings to this annex than those of its
           linked item. By "security settings", we mean "Which role(s) have
           which permissions".

           No workflow is defined on MeetingFiles, but when a MeetingFile is
           linked to a MeetingItem, we want the file to have the same
           permissions as the item. So in the MeetingItem workflow, every time
           a transition is triggered, we update the security settings of the
           MeetingFile.'''
        item = self.getItem()
        if item:
            clonePermissions(item, self)

    security.declareProtected(View, 'index_html')
    def index_html(self, REQUEST=None, RESPONSE=None):
        '''Download the file'''
        self.portal_plonemeeting.rememberAccess(self.UID())
        return ATFile.index_html(self, REQUEST, RESPONSE)

    security.declarePublic('at_post_create_script')
    def at_post_create_script(self):
        # We define here a PloneMeeting-specific modification date for this
        # annex. Indeed, we can't use the standard Plone modification_date for
        # the PloneMeeting color system because some events like item state
        # changes update security settings on annexes and modification_date is
        # updated.
        self.pm_modification_date = self.modification_date
        self.updateAnnexSecurity()
        self.portal_plonemeeting.rememberAccess(self.UID(), commitNeeded=False)
        item = self.getItem()
        if item:
            item.updateAnnexIndex(self)
            item.alreadyUsedAnnexNames.append(self.id)
        self.adapted().onEdit(isCreated=True) # Call su-product code if any

    security.declarePrivate('at_post_edit_script')
    def at_post_edit_script(self): self.adapted().onEdit(isCreated=False)

    security.declarePublic('getAnnexInfo')
    def getAnnexInfo(self):
        '''Produces a dict with some useful info about this annex. This is
           used for indexing purposes (see method updateAnnexIndex in
           MeetingItem.py).'''
        fileType = self.getMeetingFileType()
        # Decision-related ?
        decisionRelated = True
        brefs = self.getBRefs('ItemAnnexes')
        if brefs:
            decisionRelated = False
        res = {'Title': self.Title(),
               'url': self.absolute_url_path(),
               'uid': self.UID(),
               'fileTypeId': fileType.id,
               'iconUrl': fileType.absolute_url_path() + '/theIcon',
               'modification_date': self.pm_modification_date,
               'decisionRelated': decisionRelated
               }
        return res

    security.declarePublic('getSelf')
    def getSelf(self):
        if self.__class__.__name__ != 'MeetingFile': return self.context
        return self

    security.declarePublic('adapted')
    def adapted(self): return getCustomAdapter(self)

    security.declareProtected('Modify portal content', 'onEdit')
    def onEdit(self, isCreated): '''See doc in interfaces.py.'''



registerType(MeetingFile, PROJECTNAME)
# end of class MeetingFile

##code-section module-footer #fill in your manual code here
##/code-section module-footer



