## Script (Python) "listObjectButtonsActions"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=object

ignorableActions = ()

#we are just able to rename a Meeting or a MeetingAdvice...
if object.meta_type  in ['Meeting', 'MeetingAdvice', 'MeetingItem', ]:
    ignorableActions = ('copy', 'cut', 'paste', 'delete')

allActions = context.portal_actions.listFilteredActionsFor(object)

objectButtonActions = []
if allActions.has_key('object_buttons'):
    objectButtonActions = allActions['object_buttons']

res = []

for action in objectButtonActions:
    # We do not care about the paste action : no sense to paste in this view
    if not (action['id'] in ignorableActions):
        #an action is made of
        #an url
        #an image_url if exists
        #a title
        act = [action['url']]
        try:
            #we try to append the url of the icon of the action
            act.append(context.portal_actionicons.getActionIcon(action['category'], action['id']))
        except KeyError:
            #append nothing if no icon found
            act.append('')
        #we append the title
        act.append(action['title'])
        res.append(act)

return res